// Ch05  Nested Objests:  House example   Jeff Horn

import java.awt.*;
import java.awt.event.*;
import java.applet.AudioClip;
import java.net.URL;

public class HouseProgram extends EventPanel

      {

		private House house1;

	    public HouseProgram(Sounds input_clips)
	      {
	        house1 = new House(20, 40, input_clips);
	      }


	      public void paint(Graphics gr)
	      {
	        house1.paint(gr);
	      }

	      public void mousePressed(MouseEvent me)
		  	{

		      int x = me.getX();
		  	  int y = me.getY();
		  	  if(house1.inside(x,y))
		  	     {
		  	     house1.click(x,y);
		  	     repaint();
			     }

	          }

	}

	class House{
	   private Roof roof;
	   private int left, top;
       private Floor1 first;
       private Floor2 second;
       private Color houseColor;
       private int num_knobs;
       private Sounds house_clips;

	   public House(int h, int v, Sounds input_clips)
	      {
	         first = new Floor1(h,v+110);
	         second = new Floor2(h,v+30);
	         roof = new Roof(h,v);
	         left =h; top = v;
	         houseColor = Color.black;
	         num_knobs= 0;
	         house_clips = input_clips;
	      }
	   public boolean inside(int x, int y)
	        {
	            return( left < x && x < left+220 && top < y && y < top+190);
	        }
	   public void click(int x, int y)
	       {
	        if(first.inside(x,y))
	             first.click(x,y);
	             else if(houseColor == Color.black)
	                     houseColor = Color.red;
	                     else houseColor = Color.black;
            house_clips.homer.play();
	       }

	   //  Example of how to count things in nested objects!

	   public int GetNumWindows()
	       {
	        return first.GetNumWindows() + second.GetNumWindows();
	       }

	  //  Example of how to count things in nested objects!

	   private int get_num_knobs()
	        {
	          return (first.get_num_knobs() );
	            /*  + second.get_num_knobs()
	                  + roof.get_num_knobs() );
	            */
	         }


	   public void paint(Graphics g)
	      {
	        g.setColor(houseColor);
	        roof.paint(g);
	        first.paint(g);
	        second.paint(g);
	        num_knobs = get_num_knobs();
	        g.drawString("Current number of knobs:  " + num_knobs,left+50,top-10);
	      }


	  }